inlets = 1;
outlets = 3;


var textLeft="Left";
var textRight="Right";
var textTop = "Top";
var textBottom = "Bottom";

var url = "http://";

var displayText = "Display Text";

var textHeight;
var textWidth;

var fontSize = 50;

//jit.mgraphics drawing commands
var GET_DIM = "getdim";
var MOVE_TO = "move_to";
var SHOW_TEXT = "show_text";
var FILL = "fill";
var LINE_TO = "line_to";
var STROKE = "stroke";
var SET_FONT_SIZE = "set_font_size";
var TEXT_MEASURE = "text_measure";
var SET_SOURCE_RGBA = "set_source_rgba";
var PAINT = "paint";
var IDENTITY_MATRIX = "identity_matrix";
var ELLIPSE = "ellipse";
var SAVE = "save";
var RESTORE = "restore";
var ROTATE = "rotate";
var SET_SOURCE = "set_source";
var SET_LINE_WIDTH = "set_line_width";
var IMAGE_SURFACE_DRAW = "image_surface_draw";
var SCALE = "scale";
var MAX_DATA_AGE_MS = 30000.; // this should match MMConstants.DEFAULT_TIMEOUT -- we can't reference it directly because this is javascript


var scaleX = 1.0;
var scaleY = 1.0;

//display dim
var width=400.;
var height = 400.;

var average=[0,0];
var std = [0,0];
var avgColor= [1., 1., 1., .7];

var centerColor= [1., 0., 0., 1.];
var centerRadius=10;

var bgColor= [0., 0., 0., 1.];

var userArray=[];
var userColor = [1.,1.,0,1.];

var NUM_HISTORY = 250;
var historyAvgX = new Array(NUM_HISTORY);
var historyAvgY = new Array(NUM_HISTORY);
var historyCursor = 0;
var maxAvgX = -10000;
var minAvgX = 10000;
var maxAvgY = -10000;
var minAvgY = 10000;
var interpolates = [0, 0];
var N = 0;

var USER_FADE_TIME = 6000.;	//ms

function purgeUsers(){ userArray.length = 0;}


//function setAverage(x,y){ average = [x,y];}
//function setSTD(x,y){ std = [x,y];}
function setLeft(text){ textLeft=text;draw();}
function setTop(text){ textTop=text;draw();}
function setRight(text){ textRight=text;draw();}
function setBottom(text){ textBottom=text;}

function setUrl(text){ url=text;drawUrl();}
function setDisplayText(text){ displayText=text;}	
function setFontSize(fSize){fontSize=fSize;}

function setCenterRadius(radius){ centerRadius = radius; draw();}

function scaleImage(x,y){
		scaleX = x;
		scaleY = y;
	
}

function setAvg(x,y){//assumed to be 0. - 1. range
	average[0]=width*x;
	average[1]=height*y;

	// outlet(1, "cursor: " + historyCursor);
	// outlet(1, "avgX: " + average[0]);
	// outlet(1, "avgY: " + average[1]);
	outlet(2, average);
}

function setInterpolates(iX, iY)
{
	interpolates[0] = iX;
	interpolates[1] = iY;
}

function setN(n)
{
	N = n;
}

function findMax(array) {
	var ret = -10000;
	for (var i = 0; i < array.length; ++i) {
		 if (array[i] != undefined && array[i] != null && array[i] > ret)
		 	ret = array[i];
	}
	return ret;
}

function findMin(array) {
	var ret = 10000;
	for (var i = 0; i < array.length; ++i) {
		 if (array[i] != undefined && array[i] != null && array[i] < ret)
		 	ret = array[i];
	}
	return ret;
}

function setSD(x,y){
	std[0] = x*width;
	std[1] = y*height;
}

function setCenterColor(r, g, b, a){ 
	centerColor.length = 0;
	centerColor[0] = r;
	centerColor[1] = g;
	centerColor[2] = b;
	centerColor[3] = a;
	draw();
}

var a = "a";

function drawAverage(){
	//draw();
	outlet(0,SAVE);

	stdX = std[0];
	avgY=std[1];
	//x = average[0];
	//y = average[1];

	//var rangeX = maxAvgX - minAvgX;
	//var rangeY = maxAvgY - minAvgY;

	//outlet(1, "list X: " + [rangeX, interpolates[0], minAvgX, maxAvgX]);
	//outlet(1, "list Y: " + [rangeY, interpolates[1], minAvgY, maxAvgY]);

	var x = width / 2.;
	var y = height / 2.;
	x = interpolates[0];
	y = interpolates[1];
	
	// if (rangeX == 0) {
	// 	x = interpolates[0];
	// }
	// else {
	// 	x = ((interpolates[0] - minAvgX) / rangeX) * width;
	// }
	// if (rangeY == 0) {
	// 	y = interpolates[1];
	// }
	// else {
	// 	y = ((interpolates[1] - minAvgY) / rangeY) * height;
	// }

	// if (N == 1) {
	// 	x = interpolates[0];
	// 	y = interpolates[1];
	// }
	
	radial = (stdX + avgY) / 2;

	//outlet(1, "x: " + x);
	//outlet(1, "y: " + y);
	

	//outlet(0,ELLIPSE,x-stdX,y-avgY,stdX*2,avgY*2);
	outlet(0,ELLIPSE,x-radial,y-radial,radial*2,radial*2);
	outlet(0, "pattern_create_radial", "tmp", x, y, 100., x+radial/2, y+radial/2, 100.);
	outlet(0, "pattern_add_color_stop_rgba", "tmp", 0., 1., 1., 1., 0.9);
	outlet(0, "pattern_add_color_stop_rgba", "tmp", 1., 1., 1., 1., 0.);
	outlet(0, "set_source", "tmp");
	outlet(0,FILL);
	
	//outlet(0,SET_SOURCE_RGBA,avgColor);
	//outlet(0,ELLIPSE,x-stdX,y-avgY,stdX*2,avgY*2);
	//outlet(0,FILL);

	outlet(0, "translate", x - 45., y - 44.);
	//outlet(0, SCALE, 0.3, 0.3);
	outlet(0, "image_surface_draw", "buzz.png");
	
//	outlet(0,SET_SOURCE_RGBA,centerColor);
//	outlet(0,ELLIPSE,x-centerRadius,y-centerRadius,centerRadius*2,centerRadius*2);
//	outlet(0,FILL);
	outlet(0,RESTORE);


}

function clear(){

	outlet(0,SET_SOURCE_RGBA,bgColor);
	outlet(0,PAINT);
	outlet(0,SET_SOURCE_RGBA, 0, 0, 0, 1);
	outlet(0,IDENTITY_MATRIX);
	outlet(0,MOVE_TO, 0., 0.);
}

function drawUrl(){
	clear();
	outlet(0,SET_FONT_SIZE, fontSize);
	outlet(0,SET_SOURCE_RGBA, 1, 1, 1, 1);
	getTextDim(url);
	outlet(0,MOVE_TO, (width/2)-(textWidth/2), height/2);
	outlet(0,SHOW_TEXT, url);
}

function drawDisplayText(){

	clear();
	outlet(0,SET_FONT_SIZE, fontSize);
	outlet(0,SET_SOURCE_RGBA, 1, 1, 1, 1);
	getTextDim(displayText);
	outlet(0,MOVE_TO, (width/2)-(textWidth/2), height/2);
	outlet(0,SHOW_TEXT, displayText);
}


function drawImage(){
	clear();
	outlet(0,SAVE);
	outlet(0,SCALE, scaleX, scaleY);
	outlet(0,IMAGE_SURFACE_DRAW, "image");
	outlet(0,RESTORE);
	
}

function draw(){
	clear();
	drawText();
	cross();

	outlet(0,SET_SOURCE_RGBA, userColor);
	for(i=0;i<userArray.length;i++){
		userArray[i].draw();
	}
	drawAverage();
}

function drawText(){
	outlet(0,SET_FONT_SIZE, fontSize);
	outlet(0,SET_SOURCE_RGBA, 1, 1, 1, 1);

	getTextDim(textLeft);
	outlet(0,MOVE_TO,0,((height/2)+(textHeight/4)));
	outlet(0,SHOW_TEXT, textLeft);

	getTextDim(textTop);
	outlet(0,MOVE_TO,(width/2)-(textWidth/2),textHeight);
	outlet(0,SHOW_TEXT, textTop);

	getTextDim(textRight);	
	outlet(0,MOVE_TO,width-textWidth,(height/2)+(textHeight/4));
	outlet(0,SHOW_TEXT, textRight);

	getTextDim(textBottom);
	outlet(0,MOVE_TO, (width/2)-(textWidth/2),height - (textHeight/4));
	outlet(0,SHOW_TEXT, textBottom);
}

function cross(){
	//draw horizontal
	getTextDim(textLeft);
	outlet(0,SET_LINE_WIDTH,5.);
	outlet(0,MOVE_TO,textWidth,height/2);
	getTextDim(textRight);
	outlet(0,LINE_TO,width-textWidth,height/2);

	//draw vertical
	getTextDim(textTop);
	outlet(0,MOVE_TO,width/2, textHeight);
	getTextDim(textBottom);
	outlet(0,LINE_TO,width/2,height-textHeight);

	outlet(0,STROKE);
}

function reMeasure(){
	outlet(0,GET_DIM);	
}

function getTextDim(text){
	outlet(0,TEXT_MEASURE, text);
}

function text_measure(x,y){
	textWidth = x;
	textHeight = y;
}

function dim(x,y){
	width = x;
	height = y;
}


function updateUserPos(userId,inx,iny){
	x = inx*width;
	y=iny*width;
	for(i=0;i<userArray.length;i++){
		if(userArray[i].getUserId() == userId){
			userArray[i].setPosition(x,y);
			userArray[i].updateTimeStamp();
			return; //prevent code outside of loop from executing if user already in array
		}
	}
	userArray.push(new UserPoint(userId,x,y));
}

function UserPoint(userId,x,y){
	this.position =[x,y];
	this.radius= 3;
	this.color = [1.,1.,1.,1.];
	this.userId=userId;
	this.text = 'text';
	this.updateTimeStamp();
}

UserPoint.prototype.getPosition = function(){
	return this.position;
}	
UserPoint.prototype.setPosition = function(x,y){
	this.position = [x,y];
}
UserPoint.prototype.updateTimeStamp = function(){
	this.timestamp = new Date().getTime();
}
UserPoint.prototype.getTimeStamp = function(){
	return this.timestamp;
}
UserPoint.prototype.getUserId = function(){
	return this.userId;
}
UserPoint.prototype.draw = function(){
	var curTime = new Date().getTime();

	if((curTime - this.getTimeStamp()) >= MAX_DATA_AGE_MS) 
		return;

	outlet(0,SAVE);
	
	var youth = USER_FADE_TIME - (curTime - this.getTimeStamp());
	var alpha =  youth / USER_FADE_TIME;

	if (alpha > 1)
		alpha = 1.;
	else if (alpha < 0)
		alpha = 0.;

	this.color[3] = alpha;
	outlet(0,SET_SOURCE_RGBA, this.color);
	outlet(0,ELLIPSE,this.position,10,10);
	outlet(0,FILL);

	outlet(0,RESTORE);
	// if((new Date().getTime() - this.getTimeStamp()) < MAX_DATA_AGE_MS) {
	// 	outlet(0,ELLIPSE,this.position,10,10);
	// 	outlet(0,FILL);
	// }
}

function label(){
	//Left=0, Top=1, Right=2, Bottom-3
	var	position;
	var	text;
	var margin=0;
	var xOffset=0;
	var yOffset=0;

}